%{!?kernel_version: %{expand: %%define kernel_version %(uname -r)}}
%{!?kversionreltag: %{expand: %%define kversionreltag %(echo %{kernel_version} |sed -e 's/-/./g')}}
%{!?type: %{expand: %define type %(uname -r | perl -pe 's/^.*el6(.*?).*?$/$1/g'|sed -e 's/^$/smp/g')}}

%define releasetag %{kversionreltag}
%define kernel_dir %{kernel_version}

# Definitions for symvers files.
%define vmw_symvers_dir usr/lib/vmware-tools/symvers
%define bld_symvers_file Module.symvers

Name:         vmware-tools-vmhgfs
BuildRequires: kernel-devel redhat-rpm-config gcc make perl
Vendor:       VMware
License:      GPL
Group:        System/Kernel
Summary:      Contains the source needed to build the vmhgfs kernel module package (kmp) for the running kernel.
Epoch:        0
Version:      2.0.21.0
Source1:      vmhgfs-configModule.tar.gz
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

# We define this so our source packages don't contain kernel version in the release
# field but the resulting binary kmod packages they build do.  Only
# necessary on RHEL.
%{?vmw_release:Release:   %{vmw_release}.el6}
%{!?vmw_release:Release:   %{kversionreltag}.10.el6}

Source0:      vmhgfs.tar
Source2:      vmhgfs-vmware-PLDP-spec

%define kernel_version %(uname -r|perl -pe 's/^(.*el6.*)$/$1/g'|sed -e 's/^$/default/g')

# Make sure redhat-rpm-config is installed or the
# kernel_module_package macro will throw an error rather than a nice message
%{!?kernel_module_package: You must have the redhat-rpm-config package installed to build this package.}

# RHEL 6 defines the architecture as i386 by default, even though it's
# an i686 system with i686 kernels.  Define the _arch and _target_cpu
# defaults here so the user doesn't have to specify them on the
# command line
%ifarch i386
%define _arch i686
%define _target_cpu i686
%endif

# Lock down flavors to build to just the current flavor.
%{expand: %%define current_flavor %(uname -r|perl -pe 's/^.*\.el6(.*)\..*?$/$1/g'|perl -pe 's/^$/default/g')}
%kernel_module_package -s %{SOURCE2} %{current_flavor}

%prep
%setup -n vmhgfs-only

# XXX: We will need to handle the .symvers file for modules
# XXX: with dependent builds.
%build
for flavor in %flavors_to_build; do
  VMCI_SYMVERS_FILE=/%{vmw_symvers_dir}/vmci-%{kernel_version}-$flavor

  make clean
  rm -rf ../$flavor ../vmhgfs.o
  # For modules that depend on vmci, copy in the vmci symvers file
  # or die trying.
  # XXX: I can only handle dependency on one module's symvers file.
  if [ "vmhgfs" = "vsock" ]; then
     if [ ! -e $VMCI_SYMVERS_FILE ]; then
        echo
        echo
        echo "
ERROR: Could not find $VMCI_SYMVERS_FILE.  This package relies on kernel symbols for the currently running kernel that are built from the vmware-tools-vmci source RPM package.  Please do the following:

- Rebuild the vmware-tools-vmci source RPM package.
- Install the resulting binary RPM from \$HOME/rpmbuild/RPMS/\$ARCH/.
- Rebuild this package again."
        echo
        echo
        exit 1
     fi
     cp -f $VMCI_SYMVERS_FILE ./%{bld_symvers_file}
  fi

  # Build it!
  make
  mkdir ../$flavor
  cp ../vmhgfs.o ../$flavor
  # Take the symvers file with us as well.
  cp ./%{bld_symvers_file} ../$flavor/%{bld_symvers_file}
done

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
for flavor in %flavors_to_build; do
  vmhgfs_SYMVERS_FILE=%{vmw_symvers_dir}/vmhgfs-%{kernel_version}-$flavor
  if [ "$flavor" = "default" ]; then
     flavortag=""
  else
     flavortag="$flavor"
  fi
  # Install the module and symvers file.
  install -m 644 -D ../$flavor/vmhgfs.o $RPM_BUILD_ROOT/lib/modules/%{kernel_version}${flavortag}/extra/%{name}/vmhgfs.ko
  install -m 644 -D ../$flavor/%{bld_symvers_file} $RPM_BUILD_ROOT/$vmhgfs_SYMVERS_FILE
done

%description
 This package enables you to build binary kernel module packages (kmps) for vmhgfs.  The vmhgfs driver is the host-guest file system client which provides a file system interface using a specific namespace for guest user applications to perform file operations, to access or create new files which reside on the host. The vmhgfs driver communicates with the host-guest file system server which runs on the host.
